import numpy as np
from sklearn.datasets import load_svmlight_file
from sklearn.linear_model import LogisticRegression as LR
from sklearn import preprocessing
from liblinearutil import *
import sys
import argparse
parser = argparse.ArgumentParser(description='Training Logistic Regression with Scikit-Learn')

parser.add_argument('-d', '--dataset', metavar='dataset', type=str)
parser.add_argument('-m', '--mult', metavar="mult")
parser.add_argument('-s', '--solver', metavar='solver', type=str)

args = parser.parse_args(sys.argv[1:])

mult = int(args.mult)

dataset = args.dataset
dest = "../datasets/"+dataset

if dataset == "w8a":
    c = 256
elif dataset == "rcv1_train.binary":
    c = 64
elif dataset == "real-sim":
    c = 8
elif dataset == "news20.binary":
    c = 512
elif dataset == "yahoojp":
    c = 8
elif dataset == "yahookr":
    c = 64
elif dataset == "kdda":
    c = 0.125
elif dataset == "kddb":
    c = 0.5
elif dataset == "kdd12.svm":
    c = 0.0625
elif dataset == "HIGGS":
    c = 0.015625
elif dataset == "webspam_wc_normalized_trigram.svm":
    c = 4
elif dataset == "covtype":
    c = 1.19209e-07
elif dataset == "criteo.trva":
    c = 0.000030517578125
elif dataset == "url_combined":
    c = 0.0078125

c *= mult

y, x = svm_read_problem(dest, return_scipy = True)

lr = LR(C=c, random_state=np.random.RandomState(12), class_weight=None, fit_intercept=False, solver=args.solver, max_iter=10000000, penalty='l2', multi_class="ovr", tol=1e-05, n_jobs=1)
lr.fit(x,y)
